import sys
import os
import re
forge = sys.modules["forge"]

def setup(module):
	boost_sources = [
			[ "", "/usr/include", '/usr/lib64' ],

			[ "1_37", "/opt/hfs11.0.775/toolkit/include",
				'/opt/hfs11.0.775/dsolib' ],

			[ "1_46", "/opt/hfs12.0.581/toolkit/include",
				'/opt/hfs12.0.581/dsolib' ] ]

	for boost_source in boost_sources:
		if not os.path.exists(boost_source[1]) or not os.path.exists(boost_source[2]):
			sys.stdout.write("-" + boost_source[0] + " ")
			continue

		if boost_source[0] == "":
			sys.stdout.write("/ ")
		else:
			sys.stdout.write(boost_source[0] + " ")

		srcList = [	"boostregex.pmh",
					"boostregexDL" ]

		variant = boost_source[0]
		if variant != "":
			variantPath = module.modPath + '/' + variant
			if os.path.lexists(variantPath) == 0:
				os.symlink('.', variantPath)

			srcListVariant = []
			for src in srcList:
				srcListVariant += [ variant + '/' + src ]
			srcList = srcListVariant

		dllname = "fexBoostRegex" + variant

		dll = module.DLL( dllname, srcList )

		for src in srcList:
			relativePath = forge.RelativePath(forge.rootPath,module.modPath)
			modObjPath = os.path.join(forge.objPath, relativePath)
			objName = modObjPath + '/' + src
			if re.compile(r'(.*)\.pmh$').match(src):
				objName += '.gch'
			else:
				objName += forge.objsuf
			srcTarget = forge.FindTarget(objName)
			srcTarget.includemap = { 'boostregex' : boost_source[1] }

		dll.linkmap = { "boostregex" :
				"-L" + boost_source[2] + " -lboost_regex" }

		deplibs = [ "fePlatformLib" ]

		forge.deps( [ dllname + "Lib" ], deplibs )
