/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_SurfaceBindOp_h__
#define __operator_SurfaceBindOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Operator to correlate a attachable surface with a driving surface

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT SurfaceBindOp:
	public OperatorThreaded,
	public Initialize<SurfaceBindOp>
{
	public:

					SurfaceBindOp(void)										{}
virtual				~SurfaceBindOp(void)									{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

					// TODO
virtual	void		run(I32 a_id,sp<SurfaceRange> a_spRange)				{}

	protected:
		String		retrieveSignature(sp<SurfaceAccessibleI>& a_rspAccessibleI);
		void		storeSignature(sp<SurfaceAccessibleI>& a_rspAccessibleI,
							String a_signature);
		void		discardSignature(sp<SurfaceAccessibleI>& a_rspAccessibleI);

		void		retrieveParameters(sp<SurfaceAccessibleI>& a_rspAccessibleI,
							String& a_rDriverGroup,String& a_rFragmentAttribute,
							I32& a_rBindings,
							BWORD& a_rBindPrimitives,BWORD& a_rBindFragments);
		void		storeParameters(sp<SurfaceAccessibleI>& a_rspAccessibleI,
							String a_driverGroup,String a_fragmentAttribute,
							I32 a_bindCount,
							BWORD a_bindPrimitives,BWORD a_bindFragments);
		void		discardParameters(sp<SurfaceAccessibleI>& a_rspAccessibleI);

		I32			accessBindings(sp<SurfaceAccessibleI>& a_rspAccessibleI,
							std::vector< sp<SurfaceAccessorI> >&a_rFaces,
							std::vector< sp<SurfaceAccessorI> >&a_rBarys,
							I32 a_bindCount,BWORD a_bindPrimitives,
							BWORD a_allowCreation);
		void		discardBindings(sp<SurfaceAccessibleI>& a_rspAccessibleI,
							I32 a_bindCount,BWORD a_bindPrimitives);
};

} /* namespace */

#endif /* __operator_SurfaceBindOp_h__ */
